//Fortran: EQUIVALENCE ( ... )
Unit ZP14C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTZP10_p;

procedure ZP14C(A :Complex; B :Complex; C :Complex;
                var ROOT1 :Complex; var ROOT2 :Complex;
                var IERR :Integer);

implementation

procedure ZP14C(A :Complex; B :Complex; C :Complex;
                var ROOT1 :Complex; var ROOT2 :Complex;
                var IERR :Integer);
var
IS_ :Integer;
AR,AI,BR,BI,CR,CI,ZSR,ZSI,ZLR,ZLI,SCALE,TEMP :Real;
DR,DI,D,D1 :Extended;
A0,B0,C0,ZS,ZL :Complex;
AA :Array [0..1] of Real;
BB :Array [0..1] of Real;
CC :Array [0..1] of Real;
ZSA :Array [0..1] of Real;
ZLA :Array [0..1] of Real;
const
SYS063 :Real = 2.0;
SYS065 :Real = 6.931472E-1;
ZERO :Real = 0.0;
HALF :Real = 0.5;
SYS059 :Real = 3.4E38;  //  Delphi>3
label
_1,_2,_3,_4,_5,_6,_7;
begin
AR := 0.0; //  
AI := 0.0;
BR := 0.0;
BI := 0.0;
CR := 0.0;
CI := 0.0;
ZSR := 0.0;
ZSI := 0.0;
ZLR := 0.0;
ZLI := 0.0;

IERR := 0;
A0 := A;
AA[0] := A0.re;  //  EQUIVALENCE
AA[1] := A0.im;  //  EQUIVALENCE
AR := A0.re;     //  EQUIVALENCE
AI := A0.im;     //  EQUIVALENCE
B0 := SubC(Cmplx(0.0,0.0),B);
BB[0] := B0.re;  //  EQUIVALENCE
BB[1] := B0.im;  //  EQUIVALENCE
BR := B0.re;     //  EQUIVALENCE
BI := B0.im;     //  EQUIVALENCE
C0 := C;
CC[0] := C0.re;  //  EQUIVALENCE
CC[1] := C0.im;  //  EQUIVALENCE
CR := C0.re;     //  EQUIVALENCE
CI := C0.im;     //  EQUIVALENCE
if ( AR <> ZERO ) or ( AI <> ZERO )
 then goto _1;
IERR := 65;
ZL := Cmplx(SYS059,ZERO);
ZLA[0] := ZL.re;  //  EQUIVALENCE
ZLA[1] := ZL.im;  //  EQUIVALENCE
ZLR := ZL.re;     //  EQUIVALENCE
ZLI := ZL.im;     //  EQUIVALENCE
ZS := SubC(Cmplx(0.0,0.0),ZL);
ZSA[0] := ZS.re;  //  EQUIVALENCE
ZSA[1] := ZS.im;  //  EQUIVALENCE
ZSR := ZS.re;     //  EQUIVALENCE
ZSI := ZS.im;     //  EQUIVALENCE
if ( BR = ZERO ) and ( BI = ZERO )
 then goto _7;
IERR := 66;
ZS := DivC(C0,B0);
ZSA[0] := ZS.re;  //  EQUIVALENCE
ZSA[1] := ZS.im;  //  EQUIVALENCE
ZSR := ZS.re;     //  EQUIVALENCE
ZSI := ZS.im;     //  EQUIVALENCE
goto _7;
_1:
if ( CR <> ZERO ) or ( CI <> ZERO )
 then goto _2;
ZS := Cmplx(ZERO,ZERO);
ZSA[0] := ZS.re;  //  EQUIVALENCE
ZSA[1] := ZS.im;  //  EQUIVALENCE
ZSR := ZS.re;     //  EQUIVALENCE
ZSI := ZS.im;     //  EQUIVALENCE
goto _6;
_2:
IS_ := Trunc( (Ln(EMax1(Abs(AR),Abs(AI)))+Ln(EMax1(Abs(CR),
    Abs(CI)))+SYS065)/(SYS065+SYS065) );
SCALE := IntPower(SYS063,IS_);
TEMP := EMax1(Abs(BR),Abs(BI));
D1 := (TEMP);
D := D1+SCALE;
D := D-D1;
if ( (D) = ZERO )
 then goto _5;
D := D1+SCALE;
D := D-SCALE;
if ( (D) <> ZERO )
 then goto _3;
BR := ZERO;
BB[0] := BR;  //  EQUIVALENCE
B0.re := BR;  //  EQUIVALENCE
BI := ZERO;
BB[1] := BI;  //  EQUIVALENCE
B0.im := BI;  //  EQUIVALENCE
goto _4;
_3:
BR := (BR/SCALE)*HALF;
BB[0] := BR;  //  EQUIVALENCE
B0.re := BR;  //  EQUIVALENCE
BI := (BI/SCALE)*HALF;
BB[1] := BI;  //  EQUIVALENCE
B0.im := BI;  //  EQUIVALENCE
_4:
AR := AR/SCALE;
AA[0] := AR;  //  EQUIVALENCE
A0.re := AR;  //  EQUIVALENCE
AI := AI/SCALE;
AA[1] := AI;  //  EQUIVALENCE
A0.im := AI;  //  EQUIVALENCE
CR := CR/SCALE;
CC[0] := CR;  //  EQUIVALENCE
C0.re := CR;  //  EQUIVALENCE
CI := CI/SCALE;
CC[1] := CI;  //  EQUIVALENCE
C0.im := CI;  //  EQUIVALENCE
DR := IntPower(BR,2);
DI := (BI)*(2.0e0*(BR));
ZS := Cmplx((((DR-IntPower(BI,2))-(AR)*(CR))+
    (AI)*(CI)),((DI-(AI)*(CR))-
    (AR)*(CI)));
ZS := Csqrt(ZS);
ZSA[0] := ZS.re;  //  EQUIVALENCE
ZSA[1] := ZS.im;  //  EQUIVALENCE
ZSR := ZS.re;     //  EQUIVALENCE
ZSI := ZS.im;     //  EQUIVALENCE
if ( (ZSR)*(BR)+(ZSI)*(BI) <= ZERO )
 then begin
       ZS := SubC(Cmplx(0.0,0.0),
       ZS);
       ZSA[0] := ZS.re;  //  EQUIVALENCE
       ZSA[1] := ZS.im;  //  EQUIVALENCE
       ZSR := ZS.re;     //  EQUIVALENCE
       ZSI := ZS.im;     //  EQUIVALENCE
      end;
B0 := AddC(B0,ZS);
BB[0] := B0.re; //  EQUIVALENCE
BB[1] := B0.im; //  EQUIVALENCE
BR := B0.re;    //  EQUIVALENCE
BI := B0.im;    //  EQUIVALENCE
_5:
ZS := DivC(C0,B0);
ZSA[0] := ZS.re;  //  EQUIVALENCE
ZSA[1] := ZS.im;  //  EQUIVALENCE
ZSR := ZS.re;     //  EQUIVALENCE
ZSI := ZS.im;     //  EQUIVALENCE
_6:
ZL := DivC(B0,A0);
ZLA[0] := ZL.re;  //  EQUIVALENCE
ZLA[1] := ZL.im;  //  EQUIVALENCE
ZLR := ZL.re;     //  EQUIVALENCE
ZLI := ZL.im;     //  EQUIVALENCE
_7:
ROOT1 := ZS;
ROOT2 := ZL;
if ( IERR <> 0 )
 then UTZP10(IERR,141);
end;

end.
